"""
goveelights.consts

This is

"""

SUPPORTED_MODELS = [
    "H6160", "H6163", "H6104", "H6109", "H6110", "H6117", "H6159", "H7022",
    "H6086", "H6089", "H6182", "H6085", "H7014", "H5081", "H6188", "H6135",
    "H6137", "H6141", "H6142", "H6195", "H7005", "H6083", "H6002", "H6003",
    "H6148", "H6052", "H6143", "H6144", "H6050", "H6199", "H6054", "H5001",
    "H6050", "H6154", "H6143", "H6144", "H6072", "H6121", "H611A", "H5080",
    "H6062", "H614C", "H615A", "H615B", "H7020", "H7021", "H614D", "H611Z",
    "H611B", "H611C", "H615C", "H615D", "H7006", "H7007", "H7008", "H7012",
    "H7013",
]

# These are API supported commands
CMD_TURN = "turn"
CMD_BRIGHT = "brightness"
CMD_COLOR = "color"
CMD_COLOR_TEMP = "colorTem"
SUPPORTED_COMMANDS = [
    CMD_TURN,
    CMD_BRIGHT,
    CMD_COLOR,
    CMD_COLOR_TEMP
]

BRIGHTNESS_MIN = 1
BRIGHTNESS_MAX = 100
STATE_OFFLINE = False
STATE_ONLINE = True
ONLINE_STATES = (STATE_ONLINE, STATE_OFFLINE)
POWER_OFF = "off"
POWER_ON = "on"
POWER_STATES = (POWER_ON, POWER_OFF)

# These are used when building dicts information about devices
KEY_DATA = "data"
KEY_MESSAGE = "message"
KEY_CODE = "code"

KEY_BRIGHTNESS = "brightness"
KEY_CMD = "cmd"
KEY_COLOR = "color"
KEY_COLOR_TEMP = "colorTem"
KEY_COLOR_TEM_K = "colorTemInKelvin"
KEY_CONTROL = "controllable"
KEY_DEVICE = "device"
KEY_DEVICES = "devices"
KEY_DEVICE_NAME = "deviceName"
KEY_MODEL = "model"
KEY_NAME = "name"
KEY_ONLINE = "online"
KEY_POWER_STATE = "powerState"
KEY_PROPERTIES = "properties"
KEY_RANGE = "range"
KEY_RANGE_MAX = "max"
KEY_RANGE_MIN = "min"
KEY_RETRIEVE = "retrievable"
KEY_STATE_PROPERTIES = "properties"
KEY_SUPPORTED_COMMANDS = "supportCmds"
KEY_VALUE = "value"

KEY_BLUE = "b"
KEY_GREEN = "g"
KEY_RED = "r"

MODE_RGB = "rgb"
MODE_HSL = "hsl"


VALUES_PROPERTIES = [
    KEY_ONLINE,
    KEY_POWER_STATE,
    KEY_BRIGHTNESS,
    KEY_COLOR_TEMP,
    KEY_COLOR,
]

ATTR_ID = "id"
ATTR_MODEL = KEY_MODEL
ATTR_DEVICE_NAME = "device_name"
ATTR_CONTROL = KEY_CONTROL
ATTR_RETRIEVE = KEY_RETRIEVE
ATTR_SUPPORTED_COMMANDS = "supported_commands"
ATTR_COLOR_TEMP_RANGE = "color_temp_range"
ATTR_ALLOWED_MODES = "allowed_modes"
ATTR_ONLINE = KEY_ONLINE
ATTR_POWER_STATE = "power_state"
ATTR_BRIGHTNESS = KEY_BRIGHTNESS
ATTR_COLOR_MODE = "color_mode"
ATTR_COLOR = KEY_COLOR
ATTR_COLOR_TEMP = "color_temp"
ATTR_COLOR_TEMP_K = "color_temp_k"
ATTR_HUE = "hue"
ATTR_SAT = "saturation"

DEVICE_ATTRIBUTES = [
    ATTR_ID,
    ATTR_MODEL,
    ATTR_DEVICE_NAME,
    ATTR_CONTROL,
    ATTR_RETRIEVE,
    ATTR_SUPPORTED_COMMANDS,
    ATTR_COLOR_TEMP_RANGE,
    ATTR_ALLOWED_MODES,
    ATTR_ONLINE,
    ATTR_POWER_STATE,
    ATTR_BRIGHTNESS,
    ATTR_COLOR_MODE,
    ATTR_COLOR,
    ATTR_COLOR_TEMP,
]

KEY_ATTR_DICT = {
    KEY_BRIGHTNESS: ATTR_BRIGHTNESS,
    KEY_COLOR: ATTR_COLOR,
    KEY_COLOR_TEMP: ATTR_COLOR_TEMP,
    KEY_CONTROL: ATTR_CONTROL,
    KEY_DEVICE_NAME: ATTR_DEVICE_NAME,
    KEY_DEVICE: ATTR_ID,
    KEY_MODEL: ATTR_MODEL,
    KEY_ONLINE: ATTR_ONLINE,
    KEY_POWER_STATE: ATTR_POWER_STATE,
    KEY_RETRIEVE: ATTR_RETRIEVE,
    KEY_SUPPORTED_COMMANDS: ATTR_SUPPORTED_COMMANDS,
    KEY_COLOR_TEM_K: ATTR_COLOR_TEMP_K,
}

ATTR_CMD_DICT = {
    ATTR_BRIGHTNESS: CMD_BRIGHT,
    ATTR_COLOR: CMD_COLOR,
    ATTR_COLOR_TEMP: CMD_COLOR_TEMP,
    ATTR_POWER_STATE: CMD_TURN,
}
